-- stoken.e
-- Francis O Dowling June 2007
-- Freeware - do what you want with it

global function explode(sequence x, object token,integer null,integer strict)
-- explode: split a string by a string
--
-- x:       the string
-- token:   the token (string or character)
-- null:    if true, don't discard null tokens
-- strict:  if true, ALL tokens must end terminated or are not considered
   integer  tl,         -- last token
            tn          -- next token
   sequence result

   if (not sequence(token)) then
   -- need sequence for match()
      token = {token}

   end if
         
   if (length(token) = 0) then
   -- can't tokenize sequence on null token
      return x
   end if

   if (not strict) then
      -- last tokens don't have to be terminated 
      x = x & token
   end if

   result   = {}
   tl       = -length(token) + 1
   tn       = match(token,x)

   while (tn) do

      if (((tn - tl) > 1) or null) then
      -- accepts blank tokens or token is not blank

         result = append(result,x[tl + length(token) .. tn -1])

      end if

      tl = tn
      tn = match_from(token,x,tl+1)

   end while

   return result

end function

global function implode(sequence x,object token,integer null,integer strict)

   sequence result
   result = {}

   for i = 1 to length(x) do

      if (not(sequence(x[i]) and length(x[i]) = 0 and not null)) then

         result &= x[i] & token

      end if


   end for

   if (strict) then

      return result

   end if

   return result[1..$-length(token)]

end function
